typedef int Property;
typedef int Cardnum;
typedef int Cardstate;
#define CARDINUSE 1
#define CARDNEW 0 
#define CARDOLD 2

struct Card {
	Property* props;
	int n; //number of properties
	Cardnum i; //card number in the deck
	Cardstate s;
	int* img;
	int inset;
	int place;
};

void dump_card(struct Card* c) {
	int i;
	char* atr[4][3] = { 
		{"red", "grn", "blu"},
		{"ova", "dmd", "sgl"},
		{"one", "two", "thr"},
		{"ept", "hlf", "ful"}
	};
	printf("%u",c->i);
	for (i = 0; i < c->n; ++i) {
		printf(",%s", atr[i][c->props[i]]);
	}
	printf("%s", ((c->s == CARDNEW) ? "*" : "."));
	printf("\n");
}



