/*
 * ncurses client;)
 * fuksa@v-lo.krakow.pl
 * warning: endianness problems!
 */
#include<ncurses.h>
#include<stdio.h>
#include<stdlib.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<sys/select.h>
#include<netinet/in.h>
#include<netdb.h>
#include<unistd.h>

void my_die(const char* lastwords)
{
	printf("progname: ");
	perror(lastwords);
	exit(1);
}

int my_listen(const char* portnum)
{
	struct sockaddr_in adres;
	struct hostent* he;
	int port;
	char* endptr;
	int sockfd;

	port = strtol(portnum, &endptr, 0);
	if (!*portnum || *endptr) my_die("strtol");
	
	adres.sin_family = AF_INET;
	adres.sin_port = htons(port);
	adres.sin_addr.s_addr = INADDR_ANY;
	
	sockfd = socket(PF_INET, SOCK_STREAM, 0);
	if (sockfd == -1) my_die("socket");

	if (bind(sockfd, (struct sockaddr*)&adres, sizeof(adres) ) == -1) my_die("bind");

	if (listen(sockfd, 100) == -1) my_die("listen");
	return sockfd;
}


int main(int argc, char** argv)
{
	int gniazdko;
	fd_set fds;
	struct timeval tv;
	int retval;

	tv.tv_sec = 0;
	tv.tv_usec = 0;

	if (argc != 2) {
		my_die("argc!=2");
	}

	gniazdko = my_listen(argv[1]);
	

	return 0;
}
